<?php

/**
 * Доставка почтой
 */
class Shop_Delivery_Handler1 extends Shop_Delivery_Handler
{
	// тестовый режим
	private $_testMode = FALSE;

	// весовой коэффициент (расчет ведется в граммах)
	private $_coefficient = 1;

	// ограничение доставки в 100 кг
	private $_maxWeight = 100000;

	// местоположение магазина (отправки), http://postcalc.ru/ems_locations.html
	private $_from='РОСТОВ-НА-ДОНУ';

	private $_toCountries=array(
		'АВСТРАЛИЯ' => 'АВСТРАЛИЯ',
		'АВСТРИЯ' => 'АВСТРИЯ',
		'АЗЕРБАЙДЖАН' => 'АЗЕРБАЙДЖАН',
		'АЛБАНИЯ — РЕСПУБЛИКА АЛБАНИЯ' => 'АЛБАНИЯ',
		'АЛЖИР' => 'АЛЖИР',
		'АНГИЛЬЯ' => 'АНГИЛЬЯ',
		'АНГОЛА' => 'АНГОЛА',
		'АНДОРРА' => 'АНДОРРА',
		'АНТИГУА И БАРБУДА' => 'АНТИГУА И БАРБУДА',
		'АРГЕНТИНА' => 'АРГЕНТИНА',
		'АРМЕНИЯ' => 'АРМЕНИЯ',
		'АРУБА (НИДЕРЛАНДЫ)' => 'АРУБА',
		'АФГАНИСТАН' => 'АФГАНИСТАН',
		'БАНГЛАДЕШ' => 'БАНГЛАДЕШ',
		'БАРБАДОС' => 'БАРБАДОС',
		'БАХРЕЙН' => 'БАХРЕЙН',
		'БЕЛОРУССИЯ' => 'БЕЛАРУСЬ',
		'БЕЛИЗ' => 'БЕЛИЗ',
		'БЕЛЬГИЯ' => 'БЕЛЬГИЯ',
		'БЕНИН' => 'БЕНИН',
		'БЕРМУДСКИЕ ОСТРОВА (ВЕЛИКОБРИТАНИЯ)' => 'БЕРМУДСКИЕ ОСТРОВА',
		'БОЛГАРИЯ' => 'БОЛГАРИЯ',
		'БОЛИВИЯ' => 'БОЛИВИЯ',
		'БОСНИЯ И ГЕРЦЕГОВИНА' => 'БОСНИЯ И ГЕРЦЕГОВИНА',
		'БОТСВАНА' => 'БОТСВАНА',
		'БРАЗИЛИЯ' => 'БРАЗИЛИЯ',
		'БРУНЕЙ' => 'БРУНЕЙ',
		'БУРКИНА-ФАСО' => 'БУРКИНА ФАСО',
		'БУТАН' => 'БУТАН',
		'ВАНУАТУ' => 'ВАНУАТУ',
		'ВАТИКАН' => 'ВАТИКАН',
		'ВЕЛИКОБРИТАНИЯ' => 'ВЕЛИКОБРИТАНИЯ',
		'ВЕНГРИЯ' => 'ВЕНГРИЯ',
		'ВЕНЕСУЭЛА' => 'ВЕНЕСУЭЛА',
		'ВИРГИНСКИЕ ОСТРОВА (БРИТАНСКИЕ)' => 'ВИРГИНСКИЕ ОСТРОВА',
		'ВЬЕТНАМ' => 'ВЬЕТНАМ',
		'ГАБОН' => 'ГАБОН',
		'ГАМБИЯ' => 'ГАМБИЯ',
		'ГАНА' => 'ГАНА',
		'ГВАТЕМАЛА' => 'ГВАТЕМАЛА',
		'ГВИНЕЯ' => 'ГВИНЕЯ',
		'ГЕРМАНИЯ' => 'ГЕРМАНИЯ',
		'ГИБРАЛТАР (ВЕЛИКОБРИТАНИЯ)' => 'ГИБРАЛТАР',
		'ГОНКОНГ' => 'ГОНКОНГ',
		'ГОНДУРАС' => 'ГОНДУРАС',
		'ГРЕНАДА' => 'ГРЕНАДА',
		'ГРЕНЛАНДИЯ (ДАНИЯ)' => 'ГРЕНЛАНДИЯ',
		'ГРЕЦИЯ' => 'ГРЕЦИЯ',
		'ГРУЗИЯ' => 'ГРУЗИЯ',
		'ДАНИЯ' => 'ДАНИЯ',
		'ДЖИБУТИ' => 'ДЖИБУТИ',
		'ДОМИНИКА' => 'ДОМИНИКА',
		'ДОМИНИКАНСКАЯ РЕСПУБЛИКА' => 'ДОМИНИКАНСКАЯ РЕСПУБЛИКА',
		'ЕГИПЕТ' => 'ЕГИПЕТ',
		'ЗАМБИЯ' => 'ЗАМБИЯ',
		'ЗИМБАБВЕ' => 'ЗИМБАБВЕ',
		'ИЗРАИЛЬ' => 'ИЗРАИЛЬ',
		'ИНДИЯ' => 'ИНДИЯ',
		'ИНДОНЕЗИЯ' => 'ИНДОНЕЗИЯ',
		'ИОРДАНИЯ' => 'ИОРДАНИЯ',
		'ИРАК' => 'ИРАК',
		'ИРАН' => 'ИРАН',
		'ИРЛАНДИЯ' => 'ИРЛАНДИЯ',
		'ИСЛАНДИЯ' => 'ИСЛАНДИЯ',
		'ИСПАНИЯ' => 'ИСПАНИЯ',
		'ИТАЛИЯ' => 'ИТАЛИЯ',
		'ЙЕМЕН' => 'ЙЕМЕН',
		'КАЗАХСТАН' => 'КАЗАХСТАН',
		'КАЙМАНОВЫ ОСТРОВА (ВЕЛИКОБРИТАНИЯ)' => 'КАЙМАНОВЫ ОСТРОВА',
		'КАМБОДЖА' => 'КАМБОДЖА',
		'КАМЕРУН' => 'КАМЕРУН',
		'КАНАДА' => 'КАНАДА',
		'КАТАР' => 'КАТАР',
		'КЕНИЯ' => 'КЕНИЯ',
		'КИПР' => 'КИПР',
		'КИРГИЗИЯ' => 'КИРГИЗИЯ',
		'КИТАЙ' => 'КИТАЙ',
		'КОЛУМБИЯ' => 'КОЛУМБИЯ',
		'КОНГО' => 'КОНГО',
		'КОРЕЯ (СЕВЕРНАЯ)' => 'КОРЕЯ ЮЖНАЯ',
		'КОСТА-РИКА' => 'КОСТА-РИКА',
		"КОТ-Д'ИВУАР"=>"КОТ Д'ИВУАР",
		'КУБА' => 'КУБА',
		'КУВЕЙТ' => 'КУВЕЙТ',
		'ЛАОС' => 'ЛАОС',
		'ЛАТВИЯ' => 'ЛАТВИЯ',
		'ЛЕСОТО' => 'ЛЕСОТО',
		'ЛИБЕРИЯ' => 'ЛИБЕРИЯ',
		'ЛИВАН' => 'ЛИВАН',
		'ЛИВИЯ' => 'ЛИВИЯ',
		'ЛИТВА' => 'ЛИТВА',
		'ЛИХТЕНШТЕЙН' => 'ЛИХТЕНШТЕЙН',
		'ЛЮКСЕМБУРГ' => 'ЛЮКСЕМБУРГ',
		'МАВРИКИЙ' => 'МАВРИКИЙ',
		'МАВРИТАНИЯ' => 'МАВРИТАНИЯ',
		'МАДАГАСКАР' => 'МАДАГАСКАР',
		'АОМЫНЬ (МАКАО), КИТАЙ' => 'МАКАО',
		'МАКЕДОНИЯ' => 'МАКЕДОНИЯ',
		'МАЛАВИ' => 'МАЛАВИ',
		'МАЛАЙЗИЯ' => 'МАЛАЙЗИЯ',
		'МАЛИ' => 'МАЛИ',
		'МАЛЬТА' => 'МАЛЬТА',
		'МАРОККО' => 'МАРОККО',
		'МАРТИНИКА (ФРАНЦИЯ)' => 'МАРТИНИКА',
		'МЕКСИКА' => 'МЕКСИКА',
		'МИКРОНЕЗИЯ' => 'МИКРОНЕЗИЯ',
		'МОЗАМБИК' => 'МОЗАМБИК',
		'МОЛДАВИЯ' => 'МОЛДАВИЯ',
		'МОНАКО' => 'МОНАКО',
		'МОНГОЛИЯ' => 'МОНГОЛИЯ',
		'МЬЯНМА (БИРМА)' => 'МЬЯНМА',
		'НАМИБИЯ' => 'НАМИБИЯ',
		'НЕПАЛ' => 'НЕПАЛ',
		'НИГЕР' => 'НИГЕР',
		'НИГЕРИЯ' => 'НИГЕРИЯ',
		'НИКАРАГУА (ВЕЛИКОБРИТАНИЯ)' => 'НИКАРАГУА',
		'НОВАЯ ЗЕЛАНДИЯ' => 'НОВАЯ ЗЕЛАНДИЯ',
		'НОРВЕГИЯ' => 'НОРВЕГИЯ',
		'ОМАН' => 'ОМАН',
		'ПАКИСТАН' => 'ПАКИСТАН',
		'ПАНАМА' => 'ПАНАМА',
		'ПАПУА — НОВАЯ ГВИНЕЯ' => 'ПАПУА - НОВАЯ ГВИНЕЯ',
		'ПАРАГВАЙ' => 'ПАРАГВАЙ',
		'ПЕРУ' => 'ПЕРУ',
		'ПОЛЬША' => 'ПОЛЬША',
		'ПОРТУГАЛИЯ' => 'ПОРТУГАЛИЯ',
		'РОССИЯ' => 'РОССИЯ',
		'РУАНДА' => 'РУАНДА',
		'РУМЫНИЯ' => 'РУМЫНИЯ',
		'САЛЬВАДОР' => 'САЛЬВАДОР',
		'САН-МАРИНО' => 'САН МАРИНО',
		'САУДОВСКАЯ АРАВИЯ' => 'САУДОВСКАЯ АРАВИЯ',
		'СВАЗИЛЕНД' => 'СВАЗИЛЕНД',
		'СЕНЕГАЛ' => 'СЕНЕГАЛ',
		'СЕНТ-ВИНСЕНТ И ГРЕНАДИНЫ' => 'СЕНТ-ВИНСЕНТ И ГРЕНАДИНЫ',
		'СЕНТ-КИТС И НЕВИС' => 'СЕНТ-КИТС И НЕВИС',
		'СЕНТ-ЛЮСИЯ' => 'СЕНТ-ЛЮСИЯ',
		'СЕРБИЯ' => 'СЕРБИЯ',
		'СИНГАПУР' => 'СИНГАПУР',
		'СИРИЯ' => 'СИРИЯ',
		'СЛОВАКИЯ' => 'СЛОВАКИЯ',
		'СЛОВЕНИЯ' => 'СЛОВЕНИЯ',
		'СОЛОМОНОВЫ ОСТРОВА' => 'СОЛОМОНОВЫ ОСТРОВА',
		'СОМАЛИ' => 'СОМАЛИ',
		'СУДАН' => 'СУДАН',
		'СУРИНАМ' => 'СУРИНАМ',
		'СОЕДИНЕННЫЕ ШТАТЫ АМЕРИКИ' => 'США',
		'СЬЕРРА-ЛЕОНЕ' => 'СЬЕРРА-ЛЕОНЕ',
		'ТАДЖИКИСТАН' => 'ТАДЖИКИСТАН',
		'ТАЙВАНЬ (КИТАЙ)' => 'ТАЙВАНЬ',
		'ТАНЗАНИЯ' => 'ТАНЗАНИЯ',
		'ТЁРКС И КАЙКОС (ВЕЛИКОБРИТАНИЯ)' => 'ТЕРКС И КАЙКОС',
		'ТОГО' => 'ТОГО',
		'ТРИНИДАД И ТОБАГО' => 'ТРИНИДАД И ТОБАГО',
		'ТУНИС' => 'ТУНИС',
		'ТУРЦИЯ' => 'ТУРЦИЯ',
		'УГАНДА' => 'УГАНДА',
		'УЗБЕКИСТАН' => 'УЗБЕКИСТАН',
		'УКРАИНА' => 'УКРАИНА',
		'УРУГВАЙ' => 'УРУГВАЙ',
		'ФАРЕРСКИЕ ОСТРОВА (ДАНИЯ)' => 'ФАРЕРСКИЕ ОСТРОВА',
		'ФИДЖИ' => 'ФИДЖИ',
		'ФИЛИППИНЫ' => 'ФИЛИППИНЫ',
		'ФИНЛЯНДИЯ' => 'ФИНЛЯНДИЯ',
		'ФРАНЦИЯ' => 'ФРАНЦИЯ',
		'ХОРВАТИЯ' => 'ХОРВАТИЯ',
		'ЦЕНТРАЛЬНОАФРИКАНСКАЯ РЕСПУБЛИКА' => 'ЦЕНТРАЛЬНОАФРИКАНСКАЯ РЕСПУБЛИКА',
		'ЧАД' => 'ЧАД',
		'ЧЕРНОГОРИЯ' => 'ЧЕРНОГОРИЯ',
		'ЧИЛИ' => 'ЧИЛИ',
		'ШВЕЙЦАРИЯ' => 'ШВЕЙЦАРИЯ',
		'ШВЕЦИЯ' => 'ШВЕЦИЯ',
		'ЭКВАДОР' => 'ЭКВАДОР',
		'ЭСТОНИЯ' => 'ЭСТОНИЯ',
		'ЭФИОПИЯ' => 'ЭФИОПИЯ',
		'ЯМАЙКА' => 'ЯМАЙКА',
		'ЯПОНИЯ' => 'ЯПОНИЯ'
	);

	private $_toLocations=array(
		'АДЫГЕЯ' => 'АДЫГЕЯ РЕСПУБЛИКА',
		'АЛТАЙСКИЙ КРАЙ' => 'АЛТАЙСКИЙ КРАЙ',
		'АМУРСКАЯ ОБЛ.' => 'АМУРСКАЯ ОБЛАСТЬ',
		'АРХАНГЕЛЬСКАЯ ОБЛ.' => 'АРХАНГЕЛЬСКАЯ ОБЛАСТЬ',
		'АСТРАХАНСКАЯ ОБЛ.' => 'АСТРАХАНСКАЯ ОБЛАСТЬ',
		'БАШКОРТОСТАН(БАШКИРИЯ)' => 'БАШКОРТОСТАН РЕСПУБЛИКА',
		'БЕЛГОРОДСКАЯ ОБЛ.' => 'БЕЛГОРОДСКАЯ ОБЛАСТЬ',
		'БРЯНСКАЯ ОБЛ.' => 'БРЯНСКАЯ ОБЛАСТЬ',
		'БУРЯТИЯ' => 'БУРЯТИЯ РЕСПУБЛИКА',
		'ВЛАДИМИРСКАЯ ОБЛ.' => 'ВЛАДИМИРСКАЯ ОБЛАСТЬ',
		'ВОЛГОГРАДСКАЯ ОБЛ.' => 'ВОЛГОГРАДСКАЯ ОБЛАСТЬ',
		'ВОЛОГОДСКАЯ ОБЛ.' => 'ВОЛОГОДСКАЯ ОБЛАСТЬ',
		'ВОРОНЕЖСКАЯ ОБЛ.' => 'ВОРОНЕЖСКАЯ ОБЛАСТЬ',
		'ДАГЕСТАН' => 'ДАГЕСТАН РЕСПУБЛИКА',
		'ЕВРЕЙСКАЯ ОБЛ.' => 'ЕВРЕЙСКАЯ АВТОНОМНАЯ ОБЛАСТЬ',
		'ИВАНОВСКАЯ ОБЛ.' => 'ИВАНОВСКАЯ ОБЛАСТЬ',
		'ИРКУТСКАЯ ОБЛ.' => 'ИРКУТСКАЯ ОБЛАСТЬ',
		'КАЛИНИНГРАДСКАЯ ОБЛ.' => 'КАЛИНИНГРАДСКАЯ ОБЛАСТЬ',
		'КАЛМЫКИЯ' => 'КАЛМЫКИЯ РЕСПУБЛИКА',
		'КАЛУЖСКАЯ ОБЛ.' => 'КАЛУЖСКАЯ ОБЛАСТЬ',
		'КАРЕЛИЯ' => 'КАРЕЛИЯ РЕСПУБЛИКА',
		'КЕМЕРОВСКАЯ ОБЛ.' => 'КЕМЕРОВСКАЯ ОБЛАСТЬ',
		'КИРОВСКАЯ ОБЛ.' => 'КИРОВСКАЯ ОБЛАСТЬ',
		'КОМИ' => 'КОМИ РЕСПУБЛИКА',
		'КОСТРОМСКАЯ ОБЛ.' => 'КОСТРОМСКАЯ ОБЛАСТЬ',
		'КРАСНОДАРСКИЙ КРАЙ' => 'КРАСНОДАРСКИЙ КРАЙ',
		'КРАСНОЯРСКИЙ КРАЙ' => 'КРАСНОЯРСКИЙ КРАЙ',
		'КУРГАНСКАЯ ОБЛ.' => 'КУРГАНСКАЯ ОБЛАСТЬ',
		'КУРСКАЯ ОБЛ.' => 'КУРСКАЯ ОБЛАСТЬ',
		'ЛИПЕЦКАЯ ОБЛ.' => 'ЛИПЕЦКАЯ ОБЛАСТЬ',
		'МАГАДАНСКАЯ ОБЛ.' => 'МАГАДАНСКАЯ ОБЛАСТЬ',
		'МАРИЙ ЭЛ' => 'МАРИЙ ЭЛ РЕСПУБЛИКА',
		'МОРДОВИЯ' => 'МОРДОВИЯ РЕСПУБЛИКА',
		'МОСКВА И МОСКОВСКАЯ ОБЛ.' => 'МОСКОВСКАЯ ОБЛАСТЬ',
		'МУРМАНСКАЯ ОБЛ.' => 'МУРМАНСКАЯ ОБЛАСТЬ',
		'ЯМАЛО-НЕНЕЦКИЙ АО' => 'НЕНЕЦКИЙ АВТОНОМНЫЙ ОКРУГ',
		'НИЖЕГОРОДСКАЯ (ГОРЬКОВСКАЯ)' => 'НИЖЕГОРОДСКАЯ ОБЛАСТЬ',
		'НОВГОРОДСКАЯ ОБЛ.' => 'НОВГОРОДСКАЯ ОБЛАСТЬ',
		'НОВОСИБИРСКАЯ ОБЛ.' => 'НОВОСИБИРСКАЯ ОБЛАСТЬ',
		'ОРЕНБУРГСКАЯ ОБЛ.' => 'ОРЕНБУРГСКАЯ ОБЛАСТЬ',
		'ОРЛОВСКАЯ ОБЛ.' => 'ОРЛОВСКАЯ ОБЛАСТЬ',
		'ПЕНЗЕНСКАЯ ОБЛ.' => 'ПЕНЗЕНСКАЯ ОБЛАСТЬ',
		'ПЕРМСКИЙ КРАЙ' => 'ПЕРМСКИЙ КРАЙ',
		'ПРИМОРСКИЙ КРАЙ' => 'ПРИМОРСКИЙ КРАЙ',
		'ПСКОВСКАЯ ОБЛ.' => 'ПСКОВСКАЯ ОБЛАСТЬ',
		'РОСТОВСКАЯ ОБЛ.' => 'РОСТОВСКАЯ ОБЛАСТЬ',
		'РЯЗАНСКАЯ ОБЛ.' => 'РЯЗАНСКАЯ ОБЛАСТЬ',
		'САМАРСКАЯ ОБЛ.' => 'САМАРСКАЯ ОБЛАСТЬ',
		'САРАТОВСКАЯ ОБЛ.' => 'САРАТОВСКАЯ ОБЛАСТЬ',
		'САХА (ЯКУТИЯ)' => 'САХА (ЯКУТИЯ) РЕСПУБЛИКА',
		'СВЕРДЛОВСКАЯ ОБЛ.' => 'СВЕРДЛОВСКАЯ ОБЛАСТЬ',
		'СЕВЕРНАЯ ОСЕТИЯ' => 'СЕВЕРНАЯ ОСЕТИЯ-АЛАНИЯ РЕСПУБЛИКА',
		'СМОЛЕНСКАЯ ОБЛ.' => 'СМОЛЕНСКАЯ ОБЛАСТЬ',
		'СТАВРОПОЛЬСКИЙ КРАЙ' => 'СТАВРОПОЛЬСКИЙ КРАЙ',
		'ТАМБОВСКАЯ ОБЛ.' => 'ТАМБОВСКАЯ ОБЛАСТЬ',
		'ТАТАРСТАН' => 'ТАТАРСТАН РЕСПУБЛИКА',
		'ТВЕРСКАЯ ОБЛ.' => 'ТВЕРСКАЯ ОБЛАСТЬ',
		'ТОМСКАЯ ОБЛ.' => 'ТОМСКАЯ ОБЛАСТЬ',
		'ТУЛЬСКАЯ ОБЛ.' => 'ТУЛЬСКАЯ ОБЛАСТЬ',
		'ТУВА (ТУВИНСКАЯ РЕСП.)' => 'ТЫВА РЕСПУБЛИКА',
		'ТЮМЕНСКАЯ ОБЛ.' => 'ТЮМЕНСКАЯ ОБЛАСТЬ',
		'УДМУРТИЯ' => 'УДМУРТСКАЯ РЕСПУБЛИКА',
		'УЛЬЯНОВСКАЯ ОБЛ.' => 'УЛЬЯНОВСКАЯ ОБЛАСТЬ',
		'ХАБАРОВСКИЙ КРАЙ' => 'ХАБАРОВСКИЙ КРАЙ',
		'ХАКАСИЯ' => 'ХАКАСИЯ РЕСПУБЛИКА',
		'ХАНТЫ-МАНСИЙСКИЙ АО' => 'ХАНТЫ-МАНСИЙСКИЙ-ЮГРА АВТОНОМНЫЙ ОКРУГ',
		'ЧЕЛЯБИНСКАЯ ОБЛ.' => 'ЧЕЛЯБИНСКАЯ ОБЛАСТЬ',
		'ЧЕЧЕНО-ИНГУШЕТИЯ' => 'ЧЕЧЕНСКАЯ РЕСПУБЛИКА',
		'ЧУВАШИЯ' => 'ЧУВАШСКАЯ РЕСПУБЛИКА',
		'ЧУКОТСКИЙ АО' => 'ЧУКОТСКИЙ АВТОНОМНЫЙ ОКРУГ',
		'ЯМАЛО-НЕНЕЦКИЙ АО' => 'ЯМАЛО-НЕНЕЦКИЙ АВТОНОМНЫЙ ОКРУГ',
		'ЯРОСЛАВСКАЯ ОБЛ.' => 'ЯРОСЛАВСКАЯ ОБЛАСТЬ'
	);

	private $_toCities=array(
		'МОСКВА' => 'МОСКВА',
		'САНКТ-ПЕТЕРБУРГ' => 'САНКТ-ПЕТЕРБУРГ',
		'АБАКАН' => 'АБАКАН',
		'АНАДЫРЬ' => 'АНАДЫРЬ',
		'АНАПА' => 'АНАПА',
		'АРХАНГЕЛЬСК' => 'АРХАНГЕЛЬСК',
		'АСТРАХАНЬ' => 'АСТРАХАНЬ',
		'БАРНАУЛ' => 'БАРНАУЛ',
		'БЕЛГОРОД' => 'БЕЛГОРОД',
		'БИРОБИДЖАН' => 'БИРОБИДЖАН',
		'БЛАГОВЕЩЕНСК' => 'БЛАГОВЕЩЕНСК',
		'БРЯНСК' => 'БРЯНСК',
		'НОВГОРОД' => 'ВЕЛИКИЙ НОВГОРОД',
		'ВЛАДИВОСТОК' => 'ВЛАДИВОСТОК',
		'ВЛАДИКАВКАЗ' => 'ВЛАДИКАВКАЗ',
		'ВЛАДИМИР' => 'ВЛАДИМИР',
		'ВОЛГОГРАД' => 'ВОЛГОГРАД',
		'ВОЛОГДА' => 'ВОЛОГДА',
		'ВОРКУТА' => 'ВОРКУТА',
		'ВОРОНЕЖ' => 'ВОРОНЕЖ',
		'ГОРНО-АЛТАЙСК' => 'ГОРНО-АЛТАЙСК',
		'ГРОЗНЫЙ' => 'ГРОЗНЫЙ',
		'ДУДИНКА' => 'ДУДИНКА',
		'ЕКАТЕРИНБУРГ' => 'ЕКАТЕРИНБУРГ',
		'ЕЛИЗОВО' => 'ЕЛИЗОВО',
		'ИВАНОВО' => 'ИВАНОВО',
		'ИЖЕВСК' => 'ИЖЕВСК',
		'ИРКУТСК' => 'ИРКУТСК',
		'ЙОШКАР-ОЛА' => 'ЙОШКАР-ОЛА',
		'КАЗАНЬ' => 'КАЗАНЬ',
		'КАЛИНИНГРАД' => 'КАЛИНИНГРАД',
		'КАЛУГА' => 'КАЛУГА',
		'КЕМЕРОВО' => 'КЕМЕРОВО',
		'КИРОВ' => 'КИРОВ',
		'КОСТОМУКША' => 'КОСТОМУКША',
		'КОСТРОМА' => 'КОСТРОМА',
		'КРАСНОДАР' => 'КРАСНОДАР',
		'КРАСНОЯРСК' => 'КРАСНОЯРСК',
		'КУРГАН' => 'КУРГАН',
		'КУРСК' => 'КУРСК',
		'КЫЗЫЛ' => 'КЫЗЫЛ',
		'ЛИПЕЦК' => 'ЛИПЕЦК',
		'МАГАДАН' => 'МАГАДАН',
		'МАГНИТОГОРСК' => 'МАГНИТОГОРСК',
		'МАЙКОП' => 'МАЙКОП',
		'МАХАЧКАЛА' => 'МАХАЧКАЛА',
		'МИРНЫЙ' => 'МИРНЫЙ',
		'МУРМАНСК' => 'МУРМАНСК',
		'МЫТИЩИ' => 'МЫТИЩИ',
		'НАБЕРЕЖНЫЕ ЧЕЛНЫ' => 'НАБЕРЕЖНЫЕ ЧЕЛНЫ',
		'НАДЫМ' => 'НАДЫМ',
		'НАЗРАНЬ' => 'НАЗРАНЬ',
		'НАЛЬЧИК' => 'НАЛЬЧИК',
		'НАРЬЯН-МАР' => 'НАРЬЯН-МАР',
		'НЕРЮНГРИ' => 'НЕРЮНГРИ',
		'НЕФТЕЮГАНСК' => 'НЕФТЕЮГАНСК',
		'НИЖНЕВАРТОВСК' => 'НИЖНЕВАРТОВСК',
		'НИЖНИЙ НОВГОРОД' => 'НИЖНИЙ НОВГОРОД',
		'НОВОКУЗНЕЦК' => 'НОВОКУЗНЕЦК',
		'НОВОРОССИЙСК' => 'НОВОРОССИЙСК',
		'НОВОСИБИРСК' => 'НОВОСИБИРСК',
		'НОВЫЙ УРЕНГОЙ' => 'НОВЫЙ УРЕНГОЙ',
		'НОРИЛЬСК' => 'НОРИЛЬСК',
		'НОЯБРЬСК' => 'НОЯБРЬСК',
		'ОМСК' => 'ОМСК',
		'ОРЕЛ' => 'ОРЁЛ',
		'ОРЕНБУРГ' => 'ОРЕНБУРГ',
		'ПЕНЗА' => 'ПЕНЗА',
		'ПЕРМЬ' => 'ПЕРМЬ',
		'ПЕТРОЗАВОДСК' => 'ПЕТРОЗАВОДСК',
		'ПЕТРОПАВЛОВСК-КАМЧАТСКИЙ' => 'ПЕТРОПАВЛОВСК-КАМЧАТСКИЙ',
		'ПСКОВ' => 'ПСКОВ',
		'РОСТОВ-НА-ДОНУ' => 'РОСТОВ-НА-ДОНУ',
		'РЯЗАНЬ' => 'РЯЗАНЬ',
		'САЛЕХАРД' => 'САЛЕХАРД',
		'САМАРА' => 'САМАРА',
		'САРАНСК' => 'САРАНСК',
		'САРАТОВ' => 'САРАТОВ',
		'СМОЛЕНСК' => 'СМОЛЕНСК',
		'СОЧИ' => 'СОЧИ',
		'СТАВРОПОЛЬ' => 'СТАВРОПОЛЬ',
		'СТРЕЖЕВОЙ' => 'СТРЕЖЕВОЙ',
		'СУРГУТ' => 'СУРГУТ',
		'СЫКТЫВКАР' => 'СЫКТЫВКАР',
		'ТАМБОВ' => 'ТАМБОВ',
		'ТВЕРЬ' => 'ТВЕРЬ',
		'ТОЛЬЯТТИ' => 'ТОЛЬЯТТИ',
		'ТОМСК' => 'ТОМСК',
		'ТУЛА' => 'ТУЛА',
		'ТЫНДА' => 'ТЫНДА',
		'ТЮМЕНЬ' => 'ТЮМЕНЬ',
		'УЛАН-УДЭ' => 'УЛАН-УДЭ',
		'УЛЬЯНОВСК' => 'УЛЬЯНОВСК',
		'УСИНСК' => 'УСИНСК',
		'УФА' => 'УФА',
		'ХАБАРОВСК' => 'ХАБАРОВСК',
		'ХАНТЫ-МАНСИЙСК' => 'ХАНТЫ-МАНСИЙСК',
		'ХОЛМСК' => 'ХОЛМСК',
		'ЧЕБОКСАРЫ' => 'ЧЕБОКСАРЫ',
		'ЧЕЛЯБИНСК' => 'ЧЕЛЯБИНСК',
		'ЧЕРЕПОВЕЦ' => 'ЧЕРЕПОВЕЦ',
		'ЧЕРКЕССК' => 'ЧЕРКЕССК',
		'ЧИТА' => 'ЧИТА',
		'ЭЛИСТА' => 'ЭЛИСТА',
		'ЮЖНО-САХАЛИНСК' => 'ЮЖНО-САХАЛИНСК',
		'ЯКУТСК' => 'ЯКУТСК',
		'ЯРОСЛАВЛЬ' => 'ЯРОСЛАВЛЬ'
	);

	private function getData($aParams)
	{
		$aParams['o'] = 'json';

		if(!$this->_testMode)
		{
			$url = "http://api.postcalc.ru?";
			$aParams['site'] = 'site';
			$aParams['email'] = 'email';
			$aParams['person'] = 'person';
		}
		else
		{
			$url = "http://test.postcalc.ru?";
		}

		$url = $url . http_build_query($aParams);

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT_MS, 5000);
		$data = curl_exec($ch);
		curl_close($ch);
		$oResponse = json_decode($data);
		if(!is_object($oResponse) || (is_object($oResponse) && $oResponse->Status != 'OK'))
		{
			if(is_object($oResponse))
			{
				throw new Exception($oResponse->Status . " ({$oResponse->Message})");
			}
			else
			{
				ob_start();
				//var_dump($oResponse);
				throw new Exception("Ошибка: " . ob_get_clean());
			}
		}
		return $oResponse;
	}

	public function execute()
	{
		$fOrderWeight = $this->_weight * $this->_coefficient;

		if($fOrderWeight == 0 || $fOrderWeight > $this->_maxWeight)
		{
			$errorDescription = ($fOrderWeight == 0 ? "Вес равен нулю" : "Вес превышает максимально допустимые 100 кг.");
			throw new Exception("Неправильный вес ({$fOrderWeight}) [{$errorDescription}]");
		}

		// если из россиюшки
		if(!is_null($this->_shopCountry->id) && $this->_shopCountry->id == 175)
		{
			// указан город
			if(!is_null($this->_shopCity->id) && isset($this->_toCities[$this->_shopCity->name]))
			{
				$oResponse = $this->getData(array('From'=>$this->_from,'Country' => 'RU','To'=>$this->_toCities[$this->_shopCity->name],'Weight'=>$fOrderWeight));

				return $oResponse->ПростаяБандероль->Тариф;
			}
			// указана область
			elseif(!is_null($this->_shopLocation->id) && isset($this->_toLocations[mb_strtoupper($this->_shopLocation->name)]))
			{
				$oResponse = $this->getData(array('From'=>$this->_from,'Country' => 'RU','To'=>$this->_toLocations[mb_strtoupper($this->_shopLocation->name)],'Weight'=>$fOrderWeight));

				return $oResponse->ПростаяБандероль->Тариф;
			}
			// указана только россиюшка, ошибка
			else
			{
				throw new Exception("Неправильный адрес доставки [Указана только страна]");
			}
		}
		// иная страна
		elseif(!is_null($this->_shopCountry->id) && isset($this->_toCountries[$this->_shopCountry->name]))
		{
			$oResponse = $this->getData(array('From'=>$this->_from,'Country'=>$this->_toCountries[mb_strtoupper($this->_shopCountry->name)],'Weight'=>$fOrderWeight));

			return $oResponse->МждМешокМ->Тариф;
		}
		// страна не указана, ошибка
		else
		{
			throw new Exception("Неправильный адрес доставки [Страна не указана]");
		}
	}
}